%A demo of the heat equation for image denoising
%Author: Jeff Calder, 2016

I = imread('Vincent_Hall_Minnesota_5.jpg');
imshow(I);
u = double(rgb2ycbcr(I(1:3:end,1:3:end,:)));

t = 1; %number of steps between frames
T = 40; %number of frames

%add noise
u = u + 30*randn(size(u));
u0 = u;
u2 = ycbcr2rgb(uint8(u));
pause;
imshow(uint8(u2));

pause
for i=1:T
    i
    u = HeatEquation2D(u,t);
    u2 = ycbcr2rgb(uint8(u));
    imshow(uint8(u2));
    drawnow;
end
pause %Run again
u = u0;
u2 = ycbcr2rgb(uint8(u));
imshow(uint8(u2));

pause;
for i=1:T
    i
    u = HeatEquation2D(u,t);
    u2 = ycbcr2rgb(uint8(u));
    imshow(uint8(u2));
    drawnow;
end

