%A demo of the Perona-Malik equation for denoising images
%Author: Jeff Calder, 2016
I = imread('Vincent_Hall_Minnesota_5.jpg');
imshow(I);
u = double(rgb2ycbcr(I(1:3:end,1:3:end,:)));

t = 10; %number of steps between frames
T = 40; %number of frames
k = 5;

%add noise
u = u + 30*randn(size(u));
u0 = u;
u2 = ycbcr2rgb(uint8(u));
pause
imshow(uint8(u2));

pause
for i=1:T
    i
    u = PeronaMalik(u,k,t);
    u2 = ycbcr2rgb(uint8(u));
    imshow(uint8(u2));
    drawnow;
end

u=u0;
u2 = ycbcr2rgb(uint8(u));
pause
imshow(uint8(u2));

pause
T=10;
for i=1:T
    i
    u = PeronaMalik(u,k,t);
    u2 = ycbcr2rgb(uint8(u));
    imshow(uint8(u2));
    drawnow;
end
